#ifndef CONTROLPANEL_H_
#define CONTROLPANEL_H_

#include <map>
#include <msp/gltk/panel.h>
#include <msp/gltk/toggle.h>
#include "libr2c2/blockiter.h"
#include "libr2c2/train.h"

class Engineer;
class PlacementGhost;

class ControlPanel: public Msp::GLtk::Panel
{
private:
	Engineer &engineer;
	R2C2::Train &train;
	bool updating;
	std::map<unsigned, Msp::GLtk::Toggle *> tgl_funcs;

	bool placing;
	std::vector<PlacementGhost *> ghosts;
	R2C2::BlockIter place_location;

public:
	ControlPanel(Engineer &, R2C2::Train &);

private:
	void ui_function_toggled(bool, unsigned);
	void train_function_changed(unsigned, bool);
	void place_clicked();
	void place_pick_done(R2C2::Track *, unsigned);
	void take_clicked();
	void view_clicked();

	virtual void button_press(int, int, unsigned);
	virtual void pointer_motion(int, int);
};

#endif
